//audio
datablock AudioProfile(vectorShootSound)
{
   filename    = "./vector_shoot.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(vectorImpactSound)
{
   filename    = "./vector_impact.wav";
   description = AudioClose3d;
   preload = true;
};


//emitter
datablock ParticleData(vectorSmokeParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 525;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.8 0.5";
	colors[1]     = "0.5 0.5 0.8 0.0";
	sizes[0]      = 0.15;
	sizes[1]      = 0.1;

	useInvAlpha = false;
};

datablock ParticleEmitterData(vectorSmokeEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "vectorSmokeParticle";
};

datablock ParticleData(vectorLaserParticle)
{
	dragCoefficient      = 90;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 525;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.1 0.1 0.8 1";
	colors[1]     = "0.1 0.1 0.8 1";
	sizes[0]      = 0.48;
	sizes[1]      = 0.48;

	useInvAlpha = false;
};

datablock ParticleEmitterData(vectorLaserEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "vectorLaserParticle";
};

datablock ExplosionData(vectorImpactExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 100;

   soundProfile = vectorImpactSound;

   particleEmitter = vectorSmokeEmitter;
   particleDensity = 30;
	particleRadius = 0.1;
   
   faceViewer     = true;
   explosionScale = "1 1 1";


   
   shakeCamera = true;
   cameraShakeFalloff = false;
   camShakeFreq = "2.0 3.0 1.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.1;
   camShakeRadius = 0.0001;

   // Dynamic light
   lightStartRadius = 1;
   lightEndRadius = 1;
   lightStartColor = "0.0 0.0 0.0";
   lightEndColor = "0 0 0.8";
};

AddDamageType("VLaser",   '<bitmap:add-ons/Weapon_homingvector/multilaser> %1',    '%2 <bitmap:add-ons/Weapon_homingvector/multilaser> %1',0.5,1);
datablock ProjectileData(vectorProjectile)
{
   projectileShapeName = "./laser.dts";
   directDamage        = 40;
   directDamageType    = $DamageType::VLaser;
   radiusDamageType    = $DamageType::VLaser;

   impactImpulse	     = 500;
   verticalImpulse     = 600;
   explosion           = vectorImpactExplosion;

   muzzleVelocity      = 40;
   velInheritFactor    = 1;
   particleEmitter     = "vectorLaserEmitter";

   armingDelay         = 0;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = true;
   lightRadius = 1.0;
   lightColor  = "0 0 0.8";
};

//////////
// item //
//////////
datablock ItemData(vectorItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./vectorray.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Homing Vector";
	iconName = "./vectorIcon";
	doColorShift = false;
	colorShiftColor = "0.5 0.5 0.5 1.000";

	 // Dynamic properties defined by the scripts
	image = vectorImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(vectorImage)
{
   // Basic Item properties
   shapeFile = "./vectorray.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = vectorItem;
   ammo = " ";
   projectile = vectorProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   minShotTime = 1500;

   doColorShift = true;
   colorShiftColor = vectorItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.15;
	stateTransitionOnTimeout[0]     = "Ready";
	stateSequence[0]		= "Ready";
	stateSound[0]			  = weaponSwitchSound;

	stateName[1]                    = "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateAllowImageChange[1]        = true;
	stateTimeoutValue[1]		  = 0.01;

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.14;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]		  = true;
	stateEmitter[2]			  = gunFlashEmitter;
	stateEmitterTime[2]		  = 0.05;
	stateEmitterNode[2]		  = "muzzleNode";
	stateSound[2]			  = vectorShootSound;

	stateName[3] 			  = "Smoke";
	stateEmitterTime[3]		  = 0.1;
	stateEmitterNode[3]		  = "muzzleNode";
	stateTimeoutValue[3]            = 0.5;
	stateTransitionOnTimeout[3]     = "Reload";

	stateName[4]			  = "Reload";
	stateTimeoutValue[4]		  = 0.5;
	stateSequence[4]			  = "reload";
	stateTransitionOnTimeout[4]	  = "Wait";
	stateWaitForTimeout[4]		  = true;
	stateEjectShell[4]       	  = true;
	
	stateName[5]			  = "Wait";
	stateTimeoutValue[5]		  = 0.1;
	stateTransitionOnTimeout[5]	  = "Ready";
};

function vectorImage::onFire(%img,%obj,%slot)
{
	%projectile = %img.projectile;
	%spread = 0.0395;
	%shellcount = 7;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);
		%p = new Projectile()
		{
			datablock 			= %projectile;
			initialVelocity 	= %velocity;
			initialPosition 	= %obj.getMuzzlePoint(%slot);
			sourceObject 		= %obj;
			sourceSlot 			= %slot;
			client 				= %obj.client;
			scale				= %obj.scale;
			CNT					= 0;
		};
		vectorProjectile.schedule(getRandom(100,200),"ChangeForm",%p);
		MissionCleanup.add(%p);
	}
}

function vectorProjectile::changeForm(%db,%prj)
{
	initContainerRadiusSearch(%prj.getPosition(),50,$TypeMasks::PlayerObjectType);
	while(1)
	{
		%search=containerSearchNext();
		if(%prj.client==%search.client)
		{
			continue;
		}
		
		%mg=%prj.client.minigame;
		%mc=%search.client.minigame;
		%mgo=isObject(%mg);
		%mco=isObject(%mco);
		
		if(%mgo == %mco == 1)
		{
			if(%mg!$=%mc)
			{
				continue;
			}
		}
		
		if(isObject(%search))
		{
			%obj=%search;
		}
		break;
	}
	if(!isObject(%obj)) {%prj.delete();return;}
	
	%pos=vectorAdd(%obj.getPosition(),"0 0 "@ getWord(%obj.getScale(),2)*1.8);
	
	%vec=vectorSub(%pos,%prj.getPosition());
	%vec=vectorScale(vectorNormalize(%vec),vectorProjectile.muzzleVelocity);
	
	%p = new Projectile()
	{
		initialVelocity		= %vec;
		initialPosition		= %prj.getPosition();
		datablock			= vectorProjectile;
		sourceObject		= %prj.client.player;
		sourceSlot			= %prj.sourceSlot;
		client				= %prj.client;
		scale				= %prj.getScale();
		CNT					= %prj.CNT++;
	};
	if(%prj.CNT<12) {vectorProjectile.schedule(getRandom(100,200),"ChangeForm",%p);}
	%prj.delete();
}
